[![Tetra AI](https://tetra-public-assets.s3.us-west-2.amazonaws.com/model-zoo/logo.svg)](https://tetra.ai/)


# [SINet: Lightweight portrait segmentation for background removal.](https://tetra.ai/model-zoo/sinet)

SINet is a machine learning model that is designed to segment people from close-up portrait images in real time. We present an optimized implementation of the model suitable to be exported for and run on device.

This is based on the implementation of SINet found [here](https://github.com/clovaai/ext_portrait_segmentation).

More details, such as model latency and throughput running on various devices, can be found at https://tetra.ai/model-zoo/sinet


## Example & Usage

Run the demo:
```bash
python -m tetra_model_zoo.models.sinet.demo [--help]
```

See [demo.py](demo.py) for sample usage of the model and app.

Please refer to our [general instructions on using models](../../#tetra-model-zoo) for more usage instructions.


## Optimize, Profile, and Validate SINet for a device with Tetra Hub
Using Tetra Hub, you can easily optimize, profile, and validate SINet for a device.

Run the following python script to export and optimize for iOS and Android:
```bash
python -m tetra_model_zoo.models.sinet.export [ --help ]
```

## Model In-Application Deployment instructions
<a href="mailto:support@tetra.ai?subject=Request Access for Tetra Hub&body=Interest in using SINet in model zoo for deploying on-device.">Get in touch with us</a> to learn more!


## License
- Code in the Tetra Model Zoo repository is covered by the LICENSE file at the repository root.
- The license for the original implementation of SINet can be found [here](https://github.com/clovaai/ext_portrait_segmentation/blob/master/LICENSE).


## References
* [SINet: Extreme Lightweight Portrait Segmentation Networks with Spatial Squeeze Modules and Information Blocking Decoder](https://arxiv.org/abs/1911.09099)
* [Source Model Implementation](https://github.com/clovaai/ext_portrait_segmentation)
